<?php
$home = get_option('home');
global $wpdb;

/* :DEBUG: */ $wpdb->show_errors();
$event = $wpdb->get_row($wpdb->prepare("SELECT ID,name,description FROM {$wpdb->prefix}eventr_event WHERE ID=%d AND status='1'", $event_id));

if($event) {
$errors = array();
if(isset($_POST['action']) and $_POST['action']) { // Submitted Registeration
	$attendee_id = 0;
	if(!$_POST['attendee_id']) { // New attendee
		// Data validation...
		if(!$_POST['attendee_name']) $errors[] = 'Please provide a name';
		if($_POST['email'] and !preg_match('/^[\w\-\.]+\@[\w\-\.]+\.[a-z\.]{2,5}$/', $_POST['email']))  $errors[] = 'Please provide a valid email address';
	
		$image_file = '';
		if($_FILES['picture']['name']) {
			$upload_folder = joinPath(ABSPATH, get_option('upload_path'), 'eventr/');
			$image_folder = joinPath($home, get_option('upload_path'), 'eventr/');
			
			list($image, $result) = upload('picture', $upload_folder, "jpg,jpeg,png,gif,bmp"); //Upload Image
			$image_file = joinPath($image_folder, $image);
			
			if(!$image) $errors[] = 'Image upload failed: ' . $result; //Upload Failed
		}
		
		if(!count($errors)) { // No errors - insert the thingy
			$description = sanitizeInput($_POST['description']);
		
			$url = '';
			if($_POST['site_url'] != 'http://') $url = strip_tags($_POST['site_url']);
			
			//Insert the guy.
			$wpdb->query($wpdb->prepare("INSERT INTO {$wpdb->prefix}eventr_attendee(name, description, url, email, phone, picture) "
				. " VALUES(%s, %s, %s, %s, %s, '$image_file')", strip_tags($_POST['attendee_name']), $description, $url, strip_tags($_POST['email']), strip_tags($_POST['phone'])));
			$attendee_id = $wpdb->insert_id;
		}
	} else { //This attendee has attended some other function before this.
		$attendee_id = $_POST['attendee_id'];
	}
	
	if($attendee_id) {
		// First, check to see if this guy has already registered.
		if($wpdb->get_row($wpdb->prepare("SELECT added_on FROM {$wpdb->prefix}eventr_event_attendee WHERE event_ID=%d AND attendee_ID=%d", $_POST['event_id'], $attendee_id))) {
			print "You are already registered for the {$event->name} event.";
			
		} else {
			// Now, add the guy and show a success message.
			$wpdb->query($wpdb->prepare("INSERT INTO {$wpdb->prefix}eventr_event_attendee(event_ID, attendee_ID, added_on) VALUES(%d, %d, NOW())", $_POST['event_id'], $attendee_id));
			print "'$_POST[attendee_name]' has been added to the attendee list for event {$event->name}.<br />Thank you.";
		}
	
	} else { // Some error has happend - show the message.
		print "<div class='error-message'>Registeration failed... <br />" . implode('<br />', $errors) . '</div><br />';
	}
} 

if(!$_POST['action'] or $errors) { // Show The From.

	if(!isset($GLOBALS['eventr_client_includes_loaded'])) {
?>
<link type="text/css" rel="stylesheet" href="<?=$home?>/wp-content/plugins/eventr/registeration.css" />
<script type="text/javascript" src="<?=$home?>/wp-includes/js/jquery/jquery.js"></script>
<script type="text/javascript" src="<?=$home?>/wp-content/plugins/eventr/script.js"></script>

<?php
	$GLOBALS['eventr_client_includes_loaded'] = true; // Make sure that this code is not loaded more than once.
}

?>
<form action="" method="post" class="event-registeration-form" id="event-<?=$event_id?>" enctype="multipart/form-data">

<label for="attendee_name">Name</label><input type="text" name="attendee_name" id="attendee_name" value="<?=$_POST['attendee_name']?>" /><br />
<p class="help">Name is mandatory</p>
<div id="profile-search"></div>

<div id="profile-details">
<label for="description">Bio</label><textarea name="description" id="description" rows="5" cols="50"><?=$_POST['description']?></textarea><br />
<p class="help">All HTML other than the &lt;A&gt; tag will be removed. nofollow will be added to the links to prevent spamming.</p>

<label for="site_url">Url</label><input type="text" name="site_url" id="site_url" value="<?=($_POST['site_url']) ? $_POST['site_url'] : 'http://'?>" /><br />
<p class="help">Your primary site</p>

<label for="email">Email</label><input type="text" name="email" id="email" value="<?=$_POST['email']?>"/><br />
<p class="help">Your email will not be published.</p>

<label for="phone">Phone</label><input type="text" name="phone" id="phone" value="<?=$_POST['phone']?>"/><br />
<p class="help">Mobile or land-line</p>

<label for="picture">Image</label><input type="file" name="picture" id="picture" /><br />
<p class="help">150x150 picture works best</p>
</div>

<input type="submit" name="action" id="action-button" value="Register"  />
<input type="hidden" name="event_id" value="<?=$event_id?>" />
<input type="hidden" id="attendee_id" name="attendee_id" value="0" />
<input type="hidden" name="site_home" id="site_home" value="<?=$home?>" />
</form>

<?php }
} else { //Invalid event/Inactive event.
	print "Event registeration is closed.";
}

////////////////////////////////////////////////////// Library Functions ///////////////////////////////////////
/**
 * A function for easily uploading files. This function will automatically generate a new 
 *        file name so that files are not overwritten.
 * Arguments:     $file_id - The name of the input field contianing the file.
 *                $folder  - The folder to which the file should be uploaded to - it must be writable. OPTIONAL
 *                $types   - A list of comma(,) seperated extensions that can be uploaded. If it is empty, anything goes OPTIONAL
 * Returns  : This is somewhat complicated - this function returns an array with two values...
 *                The first element is randomly generated filename to which the file was uploaded to.
 *                The second element is the status - if the upload failed, it will be 'Error : Cannot upload the file 'name.txt'.' or something like that
 */
function upload($file_id, $folder="", $types="") {
    if(!$_FILES[$file_id]['name']) return array('','No file specified');

    $file_title = $_FILES[$file_id]['name'];
    //Get file extension
    $ext_arr = split("\.",basename($file_title));
    $ext = strtolower($ext_arr[count($ext_arr)-1]); //Get the last extension

    //Not really uniqe - but for all practical reasons, it is
    $uniqer = substr(md5(uniqid(rand(),1)),0,5);
    $file_name = $uniqer . '_' . $file_title;//Get Unique Name

    $all_types = explode(",",strtolower($types));
    if($types) {
        if(!in_array($ext,$all_types)) {
            $result = "'".$_FILES[$file_id]['name']."' is not a valid file."; //Show error if any.
            return array('',$result);
        }
    }

    //Where the file must be uploaded to
    if($folder) $folder .= '/';//Add a '/' at the end of the folder
    $uploadfile = $folder . $file_name;

    $result = '';
    //Move the file from the stored location to the new location
    if (!move_uploaded_file($_FILES[$file_id]['tmp_name'], $uploadfile)) {
        $result = "Cannot upload the file '".$_FILES[$file_id]['name']."'"; //Show error if any.
        if(!file_exists($folder)) {
            $result .= " : Folder don't exist.";
        } elseif(!is_writable($folder)) {
            $result .= " : Folder not writable.";
        } elseif(!is_writable($uploadfile)) {
            $result .= " : File not writable.";
        }
        $file_name = '';
        
    } else {
        if(!$_FILES[$file_id]['size']) { //Check if the file is made
            @unlink($uploadfile);//Delete the Empty file
            $file_name = '';
            $result = "Empty file found - please use a valid file."; //Show the error message
        } else {
            chmod($uploadfile,0777);//Make it universally writable.
        }
    }

    return array($file_name,$result);
}

//To remove possible evil scripts - XSS etc.
function sanitizeInput($text) {
	$allowed_tags = 'a|br|em|strong|i|b';
	$text = preg_replace("/<(\/?)($allowed_tags)([^>]*?)>/i", "&lesser;$1$2$3&greater;", $text);
	$text = strip_tags($text); //Remove all tags
	$cleaned = preg_replace("/&lesser;(\/?)($allowed_tags)( [^>]*?)?&greater;/i", "<$1$2$3>", $text);
	$cleaned = preg_replace('/<a [^>]*href=([^>]+)[^>]*>/i',"<a href=$1 rel=\"nofollow\">",$cleaned);
	
	str_replace(
		array('&'),//< and > are already covered in sanitizeInput()
		array('&amp;'),
		$text); //Convert many text reference to their HTML eqvalents.

	//Get an url and links it automatically - if it does not have a =,' or " char at the beginning. This is to prevent already linked HTML to be linked again
	$text = preg_replace(
		'/([^\'\"\=\/]|^)(http:\/\/|(www.))([\w\.\-\/\\\=\?\%\+\&]+?)([\.\?])?(\s|$)/',
		"$1<a rel='nofollow' href='http://$3$4'>$3$4</a>$5$6",
		$text);
	//That regexp will match all the following URLS
	// http://www.google.com/
	// www.google.com
	// www.google.com?option=some&other=thing
	//It is clever enough to not match
	// <a href="http://www.google.com/">
	// In case of 'www.google.com.' it will only match 'www.google.com' - the ending . is ignored

	$text=nl2br($text);
	
	return $cleaned;
}

/**
 * Takes one or more file names and combines them, using the correct path separator for the 
 * 		current platform and then return the result.
 * Arguments: The parts that make the final path.
 * Example: joinPath('/var','www/html/','try.php'); // returns '/var/www/html/try.php'
 */
function joinPath() {
	$path = '';
	$arguments = func_get_args();
	$args = array();
	foreach($arguments as $a) if($a) $args[] = $a;//Removes the empty elements
	
	$arg_count = count($args);
	for($i=0; $i<$arg_count; $i++) {
		$folder = $args[$i];
		
		if($i != 0 and $folder[0] == DIRECTORY_SEPARATOR) $folder = substr($folder,1); //Remove the first char if it is a '/' - and its not in the first argument
		if($i != $arg_count-1 and substr($folder,-1) == DIRECTORY_SEPARATOR) $folder = substr($folder,0,-1); //Remove the last char - if its not in the last argument
		
		$path .= $folder;
		if($i != $arg_count-1) $path .= DIRECTORY_SEPARATOR; //Add the '/' if its not the last element.
	}
	return $path;
}
